mime-types-0.1.0.5: Basic mime-type handling types and functions

Safe Haskell | Safe-Inferred
Language | Haskell98

Network.Mime

Contents

- Lookups
- Defaults
- Utilities
- Types

Synopsis

- mimeByExt :: MimeMap -> MimeType -> FileName -> MimeType
- defaultMimeLookup :: FileName -> MimeType
- defaultMimeType :: MimeType
- defaultMimeMap :: MimeMap
- fileNameExtensions :: FileName -> [Extension]
- type FileName = Text
- type MimeType = ByteString
- type MimeMap = Map Extension MimeType
- type Extension = Text

# Lookups

mimeByExt

Arguments

:: MimeMap |
-> MimeType | default mime type
-> FileName |
-> MimeType |

Look up a mime type from the given mime map and default mime type.

defaultMimeLookup :: FileName -> MimeType

`mimeByExt` applied to `defaultMimeType` and `defaultMimeMap`.

# Defaults

defaultMimeType :: MimeType

The default fallback mime type "application/octet-stream".

defaultMimeMap :: MimeMap

A default mapping from filename extension to mime type.

Generated from the Apache and nginx mime.types files.

# Utilities

fileNameExtensions :: FileName -> [Extension]

Get a list of all of the file name extensions.

    fileNameExtensions "foo.tar.gz" == ["tar.gz", "gz"]

# Types

type FileName = Text

The filename component of a filepath, leaving off the directory but keeping all extensions.

type MimeType = ByteString

Individual mime type for be served over the wire.

type MimeMap = Map Extension MimeType

Maps extensions to mime types.

type Extension = Text

Path extension. May include multiple components, e.g. tar.gz